// ui/accessibility/mojom/ax_location_changes.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_ACCESSIBILITY_MOJOM_AX_LOCATION_CHANGES_MOJOM_H_
#define UI_ACCESSIBILITY_MOJOM_AX_LOCATION_CHANGES_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/accessibility/mojom/ax_location_changes.mojom-features.h"  // IWYU pragma: export
#include "ui/accessibility/mojom/ax_location_changes.mojom-shared.h"  // IWYU pragma: export
#include "ui/accessibility/mojom/ax_location_changes.mojom-forward.h"  // IWYU pragma: export
#include "ui/accessibility/mojom/ax_relative_bounds.mojom.h"
#include "ui/accessibility/mojom/ax_tree_id.mojom.h"
#include <string>
#include <vector>




#include "ui/accessibility/mojom/ax_location_changes_mojom_traits.h"




namespace ax::mojom {








class  AXLocationChanges {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AXLocationChanges, T>::value>;
  using DataView = AXLocationChangesDataView;
  using Data_ = internal::AXLocationChanges_Data;

  template <typename... Args>
  static AXLocationChangesPtr New(Args&&... args) {
    return AXLocationChangesPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AXLocationChangesPtr From(const U& u) {
    return mojo::TypeConverter<AXLocationChangesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AXLocationChanges>::Convert(*this);
  }


  AXLocationChanges();

  AXLocationChanges(
      int32_t id,
      const ::ui::AXTreeID& ax_tree_id,
      const ::ui::AXRelativeBounds& new_location);


  ~AXLocationChanges();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AXLocationChangesPtr>
  AXLocationChangesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AXLocationChanges::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AXLocationChanges::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AXLocationChanges::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AXLocationChanges::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AXLocationChanges::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AXLocationChanges_UnserializedMessageContext<
            UserType, AXLocationChanges::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AXLocationChanges::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AXLocationChanges::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AXLocationChanges_UnserializedMessageContext<
            UserType, AXLocationChanges::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AXLocationChanges::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  int32_t id;
  
  ::ui::AXTreeID ax_tree_id;
  
  ::ui::AXRelativeBounds new_location;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AXLocationChanges::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AXLocationChanges::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AXLocationChanges::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AXLocationChanges::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AXLocationChangesPtr AXLocationChanges::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(ax_tree_id),
      mojo::Clone(new_location)
  );
}

template <typename T, AXLocationChanges::EnableIfSame<T>*>
bool AXLocationChanges::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->ax_tree_id, other_struct.ax_tree_id))
    return false;
  if (!mojo::Equals(this->new_location, other_struct.new_location))
    return false;
  return true;
}

template <typename T, AXLocationChanges::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.ax_tree_id < rhs.ax_tree_id)
    return true;
  if (rhs.ax_tree_id < lhs.ax_tree_id)
    return false;
  if (lhs.new_location < rhs.new_location)
    return true;
  if (rhs.new_location < lhs.new_location)
    return false;
  return false;
}


}  // ax::mojom

namespace mojo {


template <>
struct  StructTraits<::ax::mojom::AXLocationChanges::DataView,
                                         ::ax::mojom::AXLocationChangesPtr> {
  static bool IsNull(const ::ax::mojom::AXLocationChangesPtr& input) { return !input; }
  static void SetToNull(::ax::mojom::AXLocationChangesPtr* output) { output->reset(); }

  static decltype(::ax::mojom::AXLocationChanges::id) id(
      const ::ax::mojom::AXLocationChangesPtr& input) {
    return input->id;
  }

  static const decltype(::ax::mojom::AXLocationChanges::ax_tree_id)& ax_tree_id(
      const ::ax::mojom::AXLocationChangesPtr& input) {
    return input->ax_tree_id;
  }

  static const decltype(::ax::mojom::AXLocationChanges::new_location)& new_location(
      const ::ax::mojom::AXLocationChangesPtr& input) {
    return input->new_location;
  }

  static bool Read(::ax::mojom::AXLocationChanges::DataView input, ::ax::mojom::AXLocationChangesPtr* output);
};

}  // namespace mojo

#endif  // UI_ACCESSIBILITY_MOJOM_AX_LOCATION_CHANGES_MOJOM_H_